=== debian/changelog ===
blis (0.8.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Downgrade debhelper compat level to 12.

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Dec 2020 10:35:20 +0800

blis (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0 (Nov 2020)
  * Explicit configurations in descriptions for disambiguity.
  * Refresh patches and symbols control file (amd64).
  * Bump debhelper compat level to 13.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Nov 2020 09:46:47 +0800
